
#dim all

$Version = "1.00 #0218"

$Command = "PropList"
$Product = "PropList Propeller Bytecode Disassembler"
$DiskLab = "C 8GB WIN98"

%TRUE    = -1
%FALSE   =  0

Macro Boolean = Long

%PAD_ORG                = 7
%PAD_IMG                = 12
%PAD_LAB                = %PAD_IMG+17
%PAD_OPC                = %PAD_LAB+9
%PAD_OPR                = %PAD_OPC+9
%PAD_COM                = %PAD_OPR+25

%SPIN_PUB               = &h00000001&
%SPIN_SUB               = &h00000002&
%SPIN_FUN               = &h00000004&
%SPIN_JPF               = &h00000008&
%SPIN_JPT               = &h00000010&
%SPIN_LAB               = &h00000020&
%SPIN_PUSHADR           = &h00000040&

%PASM_DONE              = &h00000080&
%PASM_ORG               = &h00000100&
%PASM_LAB               = &h00000200&
%PASM_RET               = &h00000400&
%PASM_OPC               = &h00000800&
%PASM_REG               = &h00001000&
%PASM_RES               = &h00002000&
%PASM_MOVS              = &h00004000&
%PASM_MOVD              = &h00008000&

%FORTH_ORG              = &h00010000&
%FORTH_LAB              = &h00020000&

%LMM_PASM               = &h00010000&
%LMM_LAB                = &h00020000&

%AREA_OBJECT            = &h00100000&   ' Keep as first
%AREA_LINK              = &h00200000&
%AREA_SPIN              = &h00400000&
%AREA_PASM              = &h00800000&
%AREA_LMM               = &h01000000&
%AREA_JDFORTH           = &h02000000&
%AREA_PADDING           = &h04000000&
%AREA_DATA              = &h08000000&
%AREA_PINDEF            = &h10000000&   ' Keep As last

%AREA_MASK              = &h1FF00000&   ' Mask of above %AREA_*

%FLAG_XREF              = &h20000000&
%FLAG_CRLF              = &h40000000&
%FLAG_DONE              = &h80000000&

%PASM_O                 = &HFC000000&  ' OOOO OO-- ---- ---- ---- ---- ---- ----
%PASM_Z                 = &H02000000&  ' ---- --Z- ---- ---- ---- ---- ---- ----
%PASM_C                 = &H01000000&  ' ---- ---C ---- ---- ---- ---- ---- ----
%PASM_W                 = &H00800000&  ' ---- ---- W--- ---- ---- ---- ---- ----
%PASM_I                 = &H00400000&  ' ---- ---- -I-- ---- ---- ---- ---- ----
%PASM_F                 = &H003C0000&  ' ---- ---- --FF FF-- ---- ---- ---- ----
%PASM_D                 = &H0003FE00&  ' ---- ---- ---- --DD DDDD DDD- ---- ----
%PASM_S                 = &H000001FF&  ' ---- ---- ---- ---- ---- ---S SSSS SSSS

%CODE_NORMAL            = 0     ' Normal everyday code
%CODE_UNKNOWN           = 1     ' Code doesn't look quite right !
%CODE_PASMBOOT          = 3     ' Raw PASM Code as recommedned by Chip
%CODE_IMAGECRAFT        = 4     ' ImageCraft C
%CODE_AICHIPBOOT        = &h10  ' Normal everyday code but with a bootloader
%CODE_AICHIPKERN        = &h11  ' Non-AiChip Spin RAM Interpreter
%CODE_AICHIPSPIN        = &h12  ' AiChip Spin RAM Interpreter
%CODE_AICHIPPASM        = &h13  ' AiChip Pasm Interpreter
%CODE_AICHIPLMM         = &h14  ' AiChip LMM Interpreter

Declare Sub Say( Optional ByVal t$ )
Declare Function Done( ByVal pc& ) As Boolean
Declare Function PadDone( ByVal pc& ) As Boolean
Declare Function PeekLong&( ByVal pc& )
Declare Function PeekWord&( ByVal pc& )
Declare Function PeekByte&( ByVal pc& )
Declare Function PeekPack&( ByVal pc& )
Declare Function PeekLongMsbFirst&( ByVal pc& )
Declare Function PeekTripMsbFirst&( ByVal pc& )
Declare Function PeekWordMsbFirst&( ByVal pc& )
Declare Function Adr$( ByVal pc& )
Declare Function AdrForce$( ByVal pc& )
Declare Function GetLabel$( ByVal pc& )
Declare Function GetLabelDefault$( ByVal pc& )
Declare Function GetStackLabel$( ByVal i&)
Declare Function Pad$( ByVal o$, ByVal w& )
Declare Function FNstr$( Byval n& )
Declare Function CalculateChecksum&()
Declare Function GetPasmOpcode$( ByVal opcode& )
Declare Function PasmOpcodeField&( Byval opcode&, ByVal mask& )
Declare Function GetDataSize&( ByVal pc& )
Declare Function Title$
Declare Function Unpack$( ByVal n& )
Declare Function Macro_Replace$( ByVal t$, ByVal was$, ByVal now$ )
Declare Function Macro_ReplaceAll$( ByVal t$, ByVal was$, ByVal now$ )
Declare Function CastVar$( ByVal v$, ByVal cast$)
Declare Function DumpJoin$( ByVal img$, ByVal lab$, ByVal opc$, ByVal opr$, ByVal com$ )
Declare Function DevelopmentPc() As Boolean

Global image&()
Global flags&()
Global sizes&()
Global label$()
Global based&()

Global spinOpc$()
Global spinOpr$()
Global spinEfx$()

#Include "Switches.Baz"

Function PbMain&
Dim f$
Dim s$
Dim i&

  Call UpdateBuildNumber

  f$="C:\Propeller\mkeeprom\LookUp"
  f$="C:\Propeller\mkeeprom\program.eeprom"
  f$="PropTest.eeprom"
'  f$="C:\Propeller\mkeeprom\x.eeprom"
'  f$="C:\Propeller\mkeeprom\x.binary"
'  f$="C:\iccv7prop\examples.prop\BlinkLED\BlinkLED.binary"
'  f$= "Biffle.binary"

  f$ = Trim$(command$)

  if f$="" Then
    If Dir$($Command+".Ini")<>"" Then
      i& = FreeFile
      Open $Command+".Ini" For Input as #i&
      If Not Eof(i&) Then
        Line Input#i&,f$
        f$ = Trim$(f$)
        If Not Eof(i&) Then
          Line Input#i&,s$
          If s$ <> date$ Then
           f$ = ""
          End If
        End If
      End If
      Close#i&
    End If
  End If

  i& = Instr(f$,"/")
  If i& = 0 Then
    s$ = ""
  Else
    s$ = Right$(f$,Len(f$)-i&+1)
    f$ = Rtrim$(Left$(f$,i&-1))
  End If

  Call SwitchesSet(s$)

  if f$ = "" Or instr(s$,"/?") <> 0 Then
    f$ = Title$
    i& = Instr(f$,"(C)")
    f$ ="AiChip "+RTrim$(Left$(f$,i&-1))+" (C) "+Right$(date$,4)
    Print
    Print f$
    Print
    If Instr(s$,"/?") = 0 Then
      Print "Usage : PROPLIST filename{.eeprom|.binary} {/options} {/?}"
      If DevelopmentPc() Then
        Print
        Print "Use /?? for advanced options"
      End If
    Else
      Print "Usage : PROPLIST filename{.eeprom|.binary} {/options}"
      Print
      Call SwitchesHelp
    End If
  Else
    if DevelopmentPc() Then
      i& = FreeFile
      Open $Command+".Ini" For Output as #i&
      Print#i&,f$
      Print#i&,Date$
      Close#i&
    End If
    If Dir$(f$) <> "" Then
      i& = Len(f$)
      While Mid$(f$,i&,1) <> "."
        i& = i&-1
      Wend
      Call ParseImage(Left$(f$,i&-1),Right$(f$,Len(f$)-i&+1))
    Else
      If Dir$(f$+".eeprom") <> "" Then
        Call ParseImage(f$,".eeprom")
      Else
        If Dir$(f$+".binary") <> "" Then
          Call ParseImage(f$,".binary")
        Else
          Print
          Print "Cannot find image file "+f$+".*"
        End If
      End If
    End If
  End If
End Function

Function Done( ByVal pc& ) As Boolean
Global pBase&
Global vBase&
Global flags&()
  If pc& >= pBase& And pc& < vBase& Then
    Done = ( flags&(pc&) And %FLAG_DONE ) <> 0
  Else
    Done = %TRUE
  End If
End Function

Function PadDone( ByVal pc& ) As Boolean
  If Done(pc&) Then
    PadDone = %TRUE
  Else
    PadDone = PeekByte&(pc&) <> 0
  End If
End Function

Sub Mark( ByVal pc&, ByVal labelType&, byval size&, Optional ByVal fromPc& )
Global flags&()
Global sizes&()
Global sInit&
Global sEnds&
Dim oldSize&

  If pc& >= 0 And pc& <= sEnds& Then
    flags&(pc&) = flags&(pc&) Or labelType& Or %FLAG_DONE
    if size& > sizes&(pc&) Then
      sizes&(pc&) = size&
    End If
    If fromPc& <> 0 Then
      Call CrossRefMark(pc&,fromPc&)
    End If
  End If

End Sub

Sub MarkPushAdr( byval offset&, Optional ByVal addOn& )
Global heldPcx&()
Dim pc&
  pc& = heldPcx&(Abs(offset&))-1
  if pc& >= 0 And pc& < sEnds& Then
    flags&(pc&) = flags&(pc&) Or %SPIN_PUSHADR
    based&(pc&) = addOn&
  End If
End Sub

Function PeekLong&( ByVal pc& )
Dim msw&
Dim lsw&
  lsw& = PeekWord&(pc&+0)
  msw& = PeekWord&(pc&+2)
  Shift Left msw&,16
  PeekLong& = msw& Or lsw&
End Function

Function PeekWord&( ByVal pc& )
Dim msb&
Dim lsb&
  lsb& = PeekByte&(pc&+0)
  msb& = PeekByte&(pc&+1)
  Shift Left msb&,8
  PeekWord& = msb& Or lsb&
End Function

Function PeekByte&( ByVal pc& )
Global sEnds&
Global image&()
  If pc& > 0 And pc& < sEnds& Then
    PeekByte& = image&(pc&)
  Else
    PeekByte& = 0
  End If
End Function

Function PeekPack&( ByVal pc& )
Dim b&
Dim n&
  b& = PeekByte&(pc&)
  n& = 2
  Shift Left n&,( b& and &h1F)
  If (b& And &H20) <> 0 Then
    If n& = &H80000000& Then
      n& = &H7FFFFFFF&
    Else
      n& = n& - 1
    End If
  End If
  If (b& And &H40) <> 0 Then
    n& = n& Xor &HFFFFFFFF&
  End If
  PeekPack& = n&
End Function

Function PeekLongMsbFirst&( ByVal pc& )
Dim msw&
Dim lsw&
  msw& = PeekWordMsbFirst&(pc&+0)
  lsw& = PeekWordMsbFirst&(pc&+2)
  Shift Left msw&,16
  PeekLongMsbFirst& = msw& Or lsw&
End Function

Function PeekTripMsbFirst&( ByVal pc& )
Dim msb&
Dim lsw&
  msb& = PeekByte&(pc&+0)
  lsw& = PeekWordMsbFirst&(pc&+1)
  Shift Left msb&,16
  PeekTripMsbFirst& = msb& Or lsw&
End Function

Function PeekWordMsbFirst&( ByVal pc& )
Dim msb&
Dim lsb&
  msb& = PeekByte&(pc&+0)
  lsb& = PeekByte&(pc&+1)
  Shift Left msb&,8
  PeekWordMsbFirst& = msb& Or lsb&
End Function

Function PeekClockBit$( ByVal pc& )
Dim b&
Dim oprTxt$
  b& = PeekByte&(pc&)
  Select Case b& And 7
    Case 0
      oprTxt$ = oprTxt$ + "RCFAST"
      If b& <> &H0 Then
        oprTxt$ = oprTxt$ + " - Invalid Bit Settings !"
      End If
    Case 1
      oprTxt$ = oprTxt$ + "RCSLOW"
      If b& <> &H1 Then
        oprTxt$ = oprTxt$ + " - Invalid Bit Settings !"
      End If
    Case Else
      If (b& And &HA0) <> &H20 Then
        oprTxt$ = oprTxt$ + "Invalid Bit Settings !"
      Else
        Select Case b& And &H18
          Case &H00: oprTxt$ = oprTxt$ + "XINPUT"
          Case &H08: oprTxt$ = oprTxt$ + "XTAL1"
          Case &H10: oprTxt$ = oprTxt$ + "XTAL2"
          Case &H18: oprTxt$ = oprTxt$ + "XTAL3"
        End Select
        If b& And &H40 Then
          Select Case b& And 7
            Case 3: oprTxt$ = oprTxt$ + "_PLL1x"
            Case 4: oprTxt$ = oprTxt$ + "_PLL2x"
            Case 5: oprTxt$ = oprTxt$ + "_PLL4x"
            Case 6: oprTxt$ = oprTxt$ + "_PLL8x"
            Case 7: oprTxt$ = oprTxt$ + "_PLL16x"
            Case Else
              oprTxt$ = oprTxt$ + " - Invalid Bit Settings !"
          End Select
        End If
      End If
  End Select
  PeekClockBit$ = oprTxt$
End Function

Function PeekNumberValue&( ByVal pc& )
  Select Case PeekByte&(pc&)
    Case &h34 : PeekNumberValue& = -1                           ' PUSH  #-1
    Case &h35 : PeekNumberValue& = 0                            ' PUSH  #0
    Case &h36 : PeekNumberValue& = 1                            ' PUSH  #1
    Case &h37 : PeekNumberValue& = PeekPack&(pc&+1)             ' PUSH  #kp
    Case &h38 : PeekNumberValue& = PeekByte&(pc&+1)             ' PUSH  #k1
    Case &h39 : PeekNumberValue& = PeekWordMsbFirst&(pc&+1)     ' PUSH  #k2
    Case &h3A : PeekNumberValue& = PeekTripMsbFirst&(pc&+1)     ' PUSH  #k3
    Case &h3B : PeekNumberValue& = PeekLongMsbFirst&(pc&+1)     ' PUSH  #k4
    Case Else : PeekNumberValue& = 0
  End Select
End Function

Function PeekNumberSize&( ByVal pc& )
  Select Case PeekByte&(pc&)
    Case &h34 : PeekNumberSize& = 1                             ' PUSH  #-1
    Case &h35 : PeekNumberSize& = 1                             ' PUSH  #0
    Case &h36 : PeekNumberSize& = 1                             ' PUSH  #1
    Case &h37 : PeekNumberSize& = 2                             ' PUSH  #kp
    Case &h38 : PeekNumberSize& = 2                             ' PUSH  #k1
    Case &h39 : PeekNumberSize& = 3                             ' PUSH  #k2
    Case &h3A : PeekNumberSize& = 4                             ' PUSH  #k3
    Case &h3B : PeekNumberSize& = 5                             ' PUSH  #k4
    Case Else : PeekNumberSize& = 0
  End Select
End Function

Function PeekAddressSize&( ByVal pc& )
  If ( PeekByte&(pc&) And &h80 ) = 0 Then
    PeekAddressSize& = 1
  Else
    PeekAddressSize& = 2
  End If
End Function

Function PeekAddressDestination&( ByVal pc& )
Dim n&
  n& = PeekByte&(pc&)
  If ( n& And &H80 ) = 0 Then
    If ( n& And &H40 ) <> 0 Then
      n& = n& Or &hFFFFFF80&
    End If
    n& = pc&+1+n&
  Else
    n& = n& And &h7F
    Shift Left n&,8
    n& = n& Or PeekByte&(pc&+1)
    If ( n& And &H4000&) <> 0 Then
      n& = n& Or &hFFFF8000&
    End If
    n& = pc&+2+n&
  End If
  PeekAddressDestination& = n&
End Function

Function PeekVarAddressSize&( ByVal pc& )
  If ( PeekByte&(pc&) And &h80 ) = 0 Then
    PeekVarAddressSize& = 1
  Else
    PeekVarAddressSize& = 2
  End If
End Function

Function PeekVarAddress&( ByVal pc& )
Dim n&
  n& = PeekByte&(pc&)
  If ( n& And &H80 ) <> 0 Then
    n& = n& And &h7F
    Shift Left n&,8
    n& = n& Or PeekByte&(pc&+1)
  End If
  PeekVarAddress& = n&
End Function

Function Adr$( ByVal pc& )
Global pBase&
Global pInit&
Global vBase&
Global vEnds&
Global sBase&
Global sInit&
Dim lab$
  If SWITCH_USE_DESTINATION_LABELS Then
    lab$ = GetLabelDefault$(pc&)
    If Len(lab$) = 0 Then
      lab$ = "$"+Hex$(pc&,4)
    End If
  Else
    lab$ = "$"+Hex$(pc&,4)
  End If
  Adr$ = lab$
End Function

Function AdrForce$( ByVal pc& )
Dim sw As Boolean
dim o$
  sw = SWITCH_USE_DESTINATION_LABELS
  SWITCH_USE_DESTINATION_LABELS = %TRUE
  o$ = Adr$( ByVal pc& )
  SWITCH_USE_DESTINATION_LABELS = sw
  AdrForce$ = o$
End Function

Function PushAdr$(Byval pc&, ByVal n&, ByVal w&)
Global based&()
dim result$
  If SWITCH_USE_DESTINATION_LABELS Then
    If ( flags&(pc&) And %SPIN_PUSHADR ) <> 0 Then
      if based&(pc&)=0 Then
        result$ = "#"+Adr$(n&)
      Else
        result$ = "#"+Adr$(n&+based&(pc&))
        If Left$(result$,2)="#$" then
          result$ = "#"+Adr$(n&)
        End If
      End if
    Else
      result$ = "$"+Hex$(n&,w&)
    End If
  Else
    result$ = "$"+Hex$(n&,w&)
  End If
  PushAdr$=result$
End Function

Function Var$( Byval pc&, Byval t$ )
Dim v$
Dim i&
  If SWITCH_USE_VARIABLE_LABELS Then
    Select Case Mid$(t$,Len(t$)-8,4)
      Case "LOC+"
        i& = based&(pc&)
        v$ = GetStackLabel$(i&\4)
        if Len(v$) = 0 Then
          v$ = t$
        Else
          Select case i& And 3
            Case 1 : v$=v$+"+1"
            Case 2 : v$=v$+"+2"
            Case 3 : v$=v$+"+3"
          End Select
        End If
      Case "MEM+"
        v$ = GetLabel$(i&)
        If Len(v$)=0 Then
          v$ = t$
        End If
      Case Else
        v$ = GetLabel$(based&(pc&))
        If Len(v$)=0 Then
          v$ = t$
        End If
    End Select
  Else
    v$ = t$
  End If
  Var$ = v$
End Function

Function Cog$( ByVal pc&, ByVal cogPc&,ByVal opcode& , ByVal mask&, ByVal immediate As Boolean )
Global spinReg$()
dim dst&
dim lab$
  dst& = PasmOpcodeField&(opcode&,mask&)
  if mask& = %PASM_S Then
    If dst&=0 and ( flags&(pc&) And %PASM_MOVS ) <> 0 Then
      lab$ ="0-0"
    Else
      If ( opcode& And %PASM_I ) <> 0 And immediate Then
        lab$="$"+Hex$(dst&,3)
      Else
        If dst& >= &h1F0 Then
          lab$ = spinReg$( dst& And &h1F )
        Else
          lab$ = GetLabel$( pc&-(cogPc&*4)+(dst&*4) )
          If Len(lab$)=0 Then
            lab$="$"+Hex$(dst&,3)
          End If
        End If
      End If
    End If
  Else
    If dst& >= &h1F0 Then
      lab$ = spinReg$( dst& And &h1F )
    Else
      If dst&=0 and ( flags&(pc&) And %PASM_MOVD ) <> 0 Then
        lab$ ="0-0"
      Else
        lab$ = GetLabel$( pc&-(cogPc&*4)+(dst&*4) )
        If Len(lab$)=0 Then
          lab$="$"+Hex$(dst&,3)
        End If
      End If
    End If
  End If
  Cog$ = lab$
End Function

Function GetLabel$( ByVal pc& )
Global sEnds&
Global label$()
Dim lab$
  If pc& >= 0 And pc& < sEnds& Then
    lab$ = label$(pc&)
  Else
    lab$ = ""
  End If
  GetLabel$ = lab$
End Function

Function GetLabelDefault$( ByVal pc& )
Global pBase&
Global pInit&
Global vBase&
Global vEnds&
Global sBase&
Global sInit&
Global hBase&
Global tBase&
Dim lab$
  lab$ = GetLabel$(pc&)
  If Len(lab$) = 0 Then
    Select Case pc&
      Case pBase& : lab$ = "PBASE"
      Case pInit& : lab$ = "PINIT"
      Case vBase& : lab$ = "VBASE"
      Case vEnds& : lab$ = "VENDS"
      Case sBase& : lab$ = "SBASE"
      Case sInit& : lab$ = "SINIT"
      Case hBase& : lab$ = "HBASE"
      Case tBase& : lab$ = "TBASE"
      Case Else   : lab$ = ""
    End Select
  End If
  GetLabelDefault$ = lab$
End Function

Function GetStackLabel$( ByVal i& )
Global stack&()
Global stackCreated As Boolean
Global paramCount&
Global stackTop&
dim lab$
  lab$ = ""
  if stackCreated Then
    if i& >= 0 And i& <= stackTop& Then
      if stack&(i&) >= 0 Then
        If SWITCH_UNIQUE_STACK_LABELS Or i& <> 0 Then
          lab$ = "VL"+FNstr$(stack&(i&))
        Else
          lab$ = "RESULT"
        End If
      End If
    End If
  End If
  GetStackLabel$ = lab$
End Function

Function Pad$( ByVal o$, ByVal w& )
  If Len(o$) < w& Then
    Pad$ = o$ + Space$( w&-Len(o$) )
  Else
    Pad$ = o$+" "
  End If
End Function

Sub AlignAll( ByVal pc& )
Global kBoot&
  If pc& = pBase& Then
    Call Align(pc&,"PBASE","OBJECT")
  End If
  If pc& = sInit& Then
    Call Align(pc&,"SINIT","")
  End If
  If pc& = pInit& Then
    Call Align(pc&,"PINIT","SPIN")
  End If
  If pc& = vBase& Then
    Call Align(pc&,"VBASE","VARS")
  End If
  If pc& = vEnds& Then
    Call Align(pc&,"VENDS","LONG")
  End If
  If pc& = sBase& Then
    Call Align(pc&,"SBASE","")
  End If
  If pc& = kBoot& Then
    Call Align(pc&,"KBOOT","LONG")
  End If
End Sub

Sub Align( ByVal pc&, Byval lab$, ByVal alignment$, Optional Byval com$ )
Global lastAlignment$
Global labColon$
Dim o$
  if Len(lab$) <> 0 Or alignment$ <> lastAlignment$ Then
    Say
    If SWITCH_GIVE_PC_FOR_ALL_ALIGN Then
      o$=Hex$(pc&,4)
    Else
      o$=""
    End If
    If Len(alignment$)<>0 Then
      Say DumpJoin$(o$,lab$,"ALIGN",alignment$,com$)
    Else
      Say DumpJoin$(o$,lab$,"","",com$)
    End If
    Say
    lastAlignment$ = alignment$
  End If
End Sub

Function FNstr$( Byval n& )
  FNstr$ = LTrim$(Str$(n&))
End Function

Function Macro_Replace$( ByVal t$, ByVal was$, ByVal now$ )
Dim o$
Dim i&
  o$ = t$
  i& = Instr(o$,was$)
  If i& > 0 Then
    o$ = Left$(o$,i&-1)+now$+Right$(o$,Len(o$)-i&-Len(was$)+1)
  End If
  Macro_Replace$ = o$
End Function

Function Macro_ReplaceAll$( ByVal t$, ByVal was$, ByVal now$ )
Dim o$
Dim i&
  o$ = t$
  i& = Instr(o$,was$)
  While i& > 0
    o$ = Left$(o$,i&-1)+now$+Right$(o$,Len(o$)-i&-Len(was$)+1)
    i& = Instr(i&+Len(now$),o$,was$)
  Wend
  Macro_ReplaceAll$ = o$
End Function


Function GenLabel$( ByVal c$ )
Global labelNumber&
Dim i&
  labelNumber& = labelNumber&+1
  GenLabel$ = c$+FNstr$(labelNumber&-1)
End Function

Function CalculateChecksum&()
Global sEnds&
Dim hash&
Dim pc&
  hash& = 0
  For pc& = 0 To sEnds&
    hash& = ( hash& + PeekByte&(pc&) ) And &hFF
  Next
  CalculateChecksum& = hash&
End Function

Sub PokeLong( ByVal pc& , ByVal n& )
  Call PokeWord( pc&+0, n& )
  Shift Right n&,16
  Call PokeWord( pc&+2, n& )
End Sub

Sub PokeWord( ByVal pc& , ByVal n& )
  Call PokeByte( pc&+0, n& )
  Shift Right n&,8
  Call PokeByte( pc&+1, n& )
End Sub

Sub PokeByte( ByVal pc& , ByVal n& )
  image&(pc&) = n& And &hFF
End Sub

Sub PokeWordMsbFirst( ByVal pc& , ByVal n& )
  Call PokeByte( pc&+1, n& )
  Shift Right n&,8
  Call PokeByte( pc&+0, n& )
End Sub

#Include "DataBase.Baz"
#Include "JdForth.Baz"
#Include "Parse.Baz"
#Include "BootLoad.Baz"
#Include "Dump.Baz"
#Include "Stack.Baz"
#Include "PeepHole.Baz"
#Include "SymTable.Baz"
#Include "SpinFile.Baz"
#Include "CrossRef.Baz"
#Include "PinDefs.Baz"
#Include "Version.Baz"

