VAR

  byte b
  word w
  long l

  byte bOverlay[0]
  word wOverlay[0]
  long lOverlay[0]

  byte bOverlayEnd
  word wOverlayEnd
  long lOverlayEnd
  
DAT

  bData byte $12
  wData word $1234
  lData long $12345678
  
OBJ

  Obj1_A : "Obj1Test"
  Obj1_B : "Obj1Test"

  Obj2_A : "Obj2Test"
  Obj2_B : "Obj2Test"
   
PUB Main

  test_Arguments_1( 1 )
  test_Arguments_2( 1, 2 )
  test_BinaryOps
  test_BinaryOps_Assigned
  test_Case
  test_Constants
  test_Cog_Assembler
  test_Cog_Spin
  test_Cog_Spin_Args( 0, 1, 2 )
  test_If
  test_If_Else
  test_If_ElseIf
  test_IfNot_ElseIfNot
  b := test_Function_1
  b := test_Function_2
  b := test_Function_3
  if b := \test_function_Abort
    b := 0
  if b := \test_function_AbortValue
    b := 0
  b := test_Function_Nested( 1,2 )
  b := test_Function_Nested( test_Function_Nested(1,2) , test_Function_Nested(3,4) )
  b := test_Function_Nested( test_Function_Nested(1,2) , test_Function_Nested(3, test_Function_Nested(5,6) ) )
  test_Locks 
  test_Lookup_And_LookDown
  test_Memory_Ops
  test_Objects
  test_One_Line_Commands
  test_ReBoot
  test_Registers
  test_RegisterBits
  test_Repeat
  test_Repeat_Count
  test_Repeat_FromTo
  test_Repeat_Until
  test_Repeat_While
  test_Repeat_With_Next
  test_Repeat_With_Quit
  test_Strings
  test_UnaryOps
  test_UnaryOps_Assigned
  test_Vars
  test_Vars_Casting
  test_Vars_Data
  test_Vars_Local
  test_Wait

PRI test_Arguments_1(a1)

  a1 := 1
  b  := a1

PRI test_Arguments_2(a1,a2)

  a1 := 1
  b  := a1
  a2 := a1
    
PRI test_BinaryOps

  b := b + b
  b := b - b
  b := b * b
  b := b / b
  b := b // b
  b := b ** b

  b := b & b
  b := b | b
  b := b ^ b

  b := b AND b
  b := b OR  b
 
  b := b #> b
  b := b <# b
  b := b << b
  b := b >> b
  b := b <- b
  b := b -> b
  b := b ~> b
  b := b >< b
  
  b := b == b
  b := b <> b
  b := b <  b
  b := b >  b
  b := b =< b
  b := b => b

PRI test_BinaryOps_Assigned

  b += b
  b -= b
  b *= b
  b /= b
  b //= b
  b **= b

  b &= b
  b |= b
  b ^= b

  b AND= b
  b OR=  b
 
  b #>= b
  b <#= b
  b <<= b
  b >>= b
  b <-= b
  b ->= b
  b ~>= b
  b ><= b
  
  b === b
  b <>= b
  b <=  b
  b >=  b
  b =<= b
  b =>= b
 
PRI test_Case

  Case b
    1 : b := 1
    2 : b := 2

  Case b
    1..2 : b := 1
    2..3 : b := 2
    
PRI test_Cog_Assembler

  CogInit(1, @Conds, 1)
  CogNew( @Conds, 2 )

  b := CogNew( @Conds, 5 )

  CogInit(1, @Opcodes, 1)
  CogNew( @Opcodes, 2 )

  b := CogNew( @Opcodes, 5 )
  
PRI test_Cog_Spin
  
  b := CogId
                         
  CogInit(1, test_Cog_Spin, 1)
  CogNew( test_Cog_Spin, 2 )

  b := CogNew( test_Cog_Spin, 5 )

  CogInit(1, test_Cog_Spin_Args(0,1,2), 1)
  CogNew( test_Cog_Spin_Args(0,1,2), 2 )

  b := CogNew( test_Cog_Spin_Args(0,1,2), 5 )

  CogStop( 0 )
  CogStop( b )
  
PRI test_Cog_Spin_Args( arg1, arg2, arg3 )

  arg1 := arg2 + arg3
  
PRI test_Constants

  b := TRUE
  b := FALSE
  b := NEGX
  b := POSX
                      
  b := $0
  b := $1
  b := $2

  b := $0E
  b := $0F
  b := $10
  b := $11
  b := $12

  b := $1E
  b := $1F
  b := $20
  b := $21
  b := $22

  b := $2E
  b := $2F
  b := $30
  b := $31
  b := $32

  b := $3E
  b := $3F
  b := $40
  b := $41
  b := $42

  b := $4E
  b := $4F
  b := $50
  b := $51
  b := $52

  b := $5E
  b := $5F
  b := $60
  b := $61
  b := $62

  b := $6E
  b := $6F
  b := $70
  b := $71
  b := $72

  b := $7E
  b := $7F
  b := $80
  b := $81
  b := $82

  b := $8E
  b := $8F
  b := $90
  b := $91
  b := $92

  b := $9E
  b := $9F
  b := $A0
  b := $A1
  b := $A2

  b := $AE
  b := $AF
  b := $B0
  b := $B1
  b := $B2

  b := $BE
  b := $BF
  b := $C0
  b := $C1
  b := $C2

  b := $CE
  b := $CF
  b := $D0
  b := $D1
  b := $D2

  b := $DE
  b := $DF
  b := $E0
  b := $E1
  b := $E2

  b := $EE
  b := $EF
  b := $F0
  b := $F1
  b := $F2

  b := $0FE
  b := $0FF
  b := $100
  b := $101
  b := $102

  b := $1FE
  b := $1FF
  b := $200
  b := $201
  b := $202

  b := $2FE
  b := $2FF
  b := $300
  b := $301
  b := $302

  b := $3FE
  b := $3FF
  b := $400
  b := $401
  b := $402

  b := $4FE
  b := $4FF
  b := $500
  b := $501
  b := $502

  b := $5FE
  b := $5FF
  b := $600
  b := $601
  b := $602

  b := $6FE
  b := $6FF
  b := $700
  b := $701
  b := $702

  b := $7FE
  b := $7FF
  b := $800
  b := $801
  b := $802

  b := $8FE
  b := $8FF
  b := $900
  b := $901
  b := $902

  b := $9FE
  b := $9FF
  b := $A00
  b := $A01
  b := $A02

  b := $AFE
  b := $AFF
  b := $B00
  b := $B01
  b := $B02

  b := $BFE
  b := $BFF
  b := $C00
  b := $C01
  b := $C02

  b := $CFE
  b := $CFF
  b := $D00
  b := $D01
  b := $D02

  b := $DFE
  b := $DFF
  b := $E00
  b := $E01
  b := $E02

  b := $EFE
  b := $EFF
  b := $F00
  b := $F01
  b := $F02

  b := $0FFE
  b := $0FFF
  b := $1000
  b := $1001
  b := $1002

  b := $1FFE
  b := $1FFF
  b := $2000
  b := $2001
  b := $2002

  b := $2FFE
  b := $2FFF
  b := $3000
  b := $3001
  b := $3002

  b := $3FFE
  b := $3FFF
  b := $4000
  b := $4001
  b := $4002

  b := $4FFE
  b := $4FFF
  b := $5000
  b := $5001
  b := $5002

  b := $5FFE
  b := $5FFF
  b := $6000
  b := $6001
  b := $6002

  b := $6FFE
  b := $6FFF
  b := $7000
  b := $7001
  b := $7002

  b := $7FFE
  b := $7FFF
  b := $8000
  b := $8001
  b := $8002

  b := $8FFE
  b := $8FFF
  b := $9000
  b := $9001
  b := $9002

  b := $9FFE
  b := $9FFF
  b := $A000
  b := $A001
  b := $A002

  b := $AFFE
  b := $AFFF
  b := $B000
  b := $B001
  b := $B002

  b := $BFFE
  b := $BFFF
  b := $C000
  b := $C001
  b := $C002

  b := $CFFE
  b := $CFFF
  b := $D000
  b := $D001
  b := $D002

  b := $DFFE
  b := $DFFF
  b := $E000
  b := $E001
  b := $E002

  b := $EFFE
  b := $EFFF
  b := $F000
  b := $F001
  b := $F002

  b := $0FFFE
  b := $0FFFF
  b := $10000
  b := $10001
  b := $10002

  b := $1FFFE
  b := $1FFFF
  b := $20000
  b := $20001
  b := $20002

  b := $2FFFE
  b := $2FFFF
  b := $30000
  b := $30001
  b := $30002

  b := $3FFFE
  b := $3FFFF
  b := $40000
  b := $40001
  b := $40002

  b := $4FFFE
  b := $4FFFF
  b := $50000
  b := $50001
  b := $50002

  b := $5FFFE
  b := $5FFFF
  b := $60000
  b := $60001
  b := $60002

  b := $6FFFE
  b := $6FFFF
  b := $70000
  b := $70001
  b := $70002

  b := $7FFFE
  b := $7FFFF
  b := $80000
  b := $80001
  b := $80002

  b := $8FFFE
  b := $8FFFF
  b := $90000
  b := $90001
  b := $90002

  b := $9FFFE
  b := $9FFFF
  b := $A0000
  b := $A0001
  b := $A0002

  b := $AFFFE
  b := $AFFFF
  b := $B0000
  b := $B0001
  b := $B0002

  b := $BFFFE
  b := $BFFFF
  b := $C0000
  b := $C0001
  b := $C0002

  b := $CFFFE
  b := $CFFFF
  b := $D0000
  b := $D0001
  b := $D0002

  b := $DFFFE
  b := $DFFFF
  b := $E0000
  b := $E0001
  b := $E0002

  b := $EFFFE
  b := $EFFFF
  b := $F0000
  b := $F0001
  b := $F0002

  b := $0FFFFE
  b := $0FFFFF
  b := $100000
  b := $100001
  b := $100002

  b := $1FFFFE
  b := $1FFFFF
  b := $200000
  b := $200001
  b := $200002

  b := $2FFFFE
  b := $2FFFFF
  b := $300000
  b := $300001
  b := $300002

  b := $3FFFFE
  b := $3FFFFF
  b := $400000
  b := $400001
  b := $400002

  b := $4FFFFE
  b := $4FFFFF
  b := $500000
  b := $500001
  b := $500002

  b := $5FFFFE
  b := $5FFFFF
  b := $600000
  b := $600001
  b := $600002

  b := $6FFFFE
  b := $6FFFFF
  b := $700000
  b := $700001
  b := $700002

  b := $7FFFFE
  b := $7FFFFF
  b := $800000
  b := $800001
  b := $800002

  b := $8FFFFE
  b := $8FFFFF
  b := $900000
  b := $900001
  b := $900002

  b := $9FFFFE
  b := $9FFFFF
  b := $A00000
  b := $A00001
  b := $A00002

  b := $AFFFFE
  b := $AFFFFF
  b := $B00000
  b := $B00001
  b := $B00002

  b := $BFFFFE
  b := $BFFFFF
  b := $C00000
  b := $C00001
  b := $C00002

  b := $CFFFFE
  b := $CFFFFF
  b := $D00000
  b := $D00001
  b := $D00002

  b := $DFFFFE
  b := $DFFFFF
  b := $E00000
  b := $E00001
  b := $E00002

  b := $EFFFFF
  b := $EFFFFF
  b := $F00000
  b := $F00001
  b := $F00002

  b := $0FFFFFE
  b := $0FFFFFF
  b := $1000000
  b := $1000001
  b := $1000002

  b := $1FFFFFE
  b := $1FFFFFF
  b := $2000000
  b := $2000001
  b := $2000002

  b := $2FFFFFE
  b := $2FFFFFF
  b := $3000000
  b := $3000001
  b := $3000002

  b := $3FFFFFE
  b := $3FFFFFF
  b := $4000000
  b := $4000001
  b := $4000002

  b := $4FFFFFE
  b := $4FFFFFF
  b := $5000000
  b := $5000001
  b := $5000002

  b := $5FFFFFE
  b := $5FFFFFF
  b := $6000000
  b := $6000001
  b := $6000002

  b := $6FFFFFE
  b := $6FFFFFF
  b := $7000000
  b := $7000001
  b := $7000002

  b := $7FFFFFE
  b := $7FFFFFF
  b := $8000000
  b := $8000001
  b := $8000002

  b := $8FFFFFE
  b := $8FFFFFF
  b := $9000000
  b := $9000001
  b := $9000002

  b := $9FFFFFE
  b := $9FFFFFF
  b := $A000000
  b := $A000001
  b := $A000002

  b := $AFFFFFE
  b := $AFFFFFF
  b := $B000000
  b := $B000001
  b := $B000002

  b := $BFFFFFE
  b := $BFFFFFF
  b := $C000000
  b := $C000001
  b := $C000002

  b := $CFFFFFE
  b := $CFFFFFF
  b := $D000000
  b := $D000001
  b := $D000002

  b := $DFFFFFE
  b := $DFFFFFF
  b := $E000000
  b := $E000001
  b := $E000002

  b := $EFFFFFE
  b := $EFFFFFF
  b := $F000000
  b := $F000001
  b := $F000002

  b := $0FFFFFFE
  b := $0FFFFFFF
  b := $10000000
  b := $10000001
  b := $10000002

  b := $1FFFFFFE
  b := $1FFFFFFF
  b := $20000000
  b := $20000001
  b := $20000002

  b := $2FFFFFFE
  b := $2FFFFFFF
  b := $30000000
  b := $30000001
  b := $30000002

  b := $3FFFFFFE
  b := $3FFFFFFF
  b := $40000000
  b := $40000001
  b := $40000002

  b := $4FFFFFFE
  b := $4FFFFFFF
  b := $50000000
  b := $50000001
  b := $50000002

  b := $5FFFFFFE
  b := $5FFFFFFF
  b := $60000000
  b := $60000001
  b := $60000002

  b := $6FFFFFFE
  b := $6FFFFFFF
  b := $70000000
  b := $70000001
  b := $70000002

  b := $7FFFFFFE
  b := $7FFFFFFF
  b := $80000000
  b := $80000001
  b := $80000002

  b := $8FFFFFFE
  b := $8FFFFFFF
  b := $90000000
  b := $90000001
  b := $90000002

  b := $9FFFFFFE
  b := $9FFFFFFF
  b := $A0000000
  b := $A0000001
  b := $A0000002

  b := $AFFFFFFE
  b := $AFFFFFFF
  b := $B0000000
  b := $B0000001
  b := $B0000002

  b := $BFFFFFFE
  b := $BFFFFFFF
  b := $C0000000
  b := $C0000001
  b := $C0000002

  b := $CFFFFFFE
  b := $CFFFFFFF
  b := $D0000000
  b := $D0000001
  b := $D0000002

  b := $DFFFFFFE
  b := $DFFFFFFF
  b := $E0000000
  b := $E0000001
  b := $E0000002

  b := $EFFFFFFE
  b := $EFFFFFFF
  b := $F0000000
  b := $F0000001
  b := $F0000002

  b := $FFFFFFFE
  b := $FFFFFFFF

PRI test_Function_1

  Return b

PRI test_Function_2 : returnValue

  returnValue := b

PRI test_Function_3

  Result := b
  
PRI test_Function_Abort

  Abort

PRI test_Function_AbortValue

  Abort 0

PRI test_Function_Nested( arg1 ,  arg2 )

  RETURN arg1 + arg2
  
PRI test_If

  If b == 0
    b := 0

  If b <> 1
    b := 1

PRI test_If_Else

  If b == 0
    b := 0
  Else
    b := 1

PRI test_If_ElseIf

  If b == 0
    b := 0
  ElseIf b == 1
    b := 1
  Else
    b := 2

PRI test_IfNot_ElseIfNot

  IfNot b == 0
    b := 0
  ElseIfNot b == 1
    b := 1
  Else
    b := 2
    
PRI test_Locks

  LockClr(b)
  LockNew
  LockRet(b)
  LockSet(b)

  b := LockClr(b)
  b := LockNew
  b := LockSet(b)
  
PRI test_Lookup_And_LookDown

  b := LookUp( b : 1, 2, 3 )
  b := LookDown( b : 1, 2, 3 )

  b := LookUpZ( b : 1, 2, 3 )
  b := LookDownZ( b : 1, 2, 3 )
   
  b := LookUp( b : 1..2, 2..3, 3..4 )
  b := LookDown( b : 1..2, 2..3, 3..4 )

  b := LookUpZ( b : 1..2, 2..3, 3..4 )
  b := LookDownZ( b : 1..2, 2..3, 3..4 )

PRI test_Memory_Ops

  ByteFill( @b, 0, 1 )
  Wordfill( @b, 0, 2 )
  Longfill( @b, 0, 3 )

  ByteMove( @b, @b, 1 )
  WordMove( @b, @b, 2 )
  LongMove( @b, @b, 3 )

PRI test_Objects

  Obj1_A.Start
  Obj1_A.Stop

  Obj1_B.Start
  Obj1_B.Stop

  b := Obj1_A.Func
  b := Obj1_B.Func

  Obj2_A.Start
  Obj2_A.Stop

  Obj2_B.Start
  Obj2_B.Stop

  b := Obj2_A.Func
  b := Obj2_B.Func
  
PRI test_One_Line_Commands

  b := ChipVer
  b := ClkFreq
  b := ClkMode
  ClkSet( 0, 1 ) 
  b := Cnt

PRI test_ReBoot

  ReBoot
  
PRI test_Registers

  CTRA   := CTRB
  DIRA   := DIRB
  FRQA   := FRQB
  INA    := INA
  INB    := INB
  OUTA   := OUTA
  OUTB   := OUTB
  PAR    := PAR
  PHSA   := PHSB
  VCFG   := VCFG
  VSCL   := VSCL
  
  SPR[0] := SPR[1]
  SPR[2] ++
  
PRI test_RegisterBits

  OUTA[0] := 0
  OUTB[1] := 1

  OUTA[0..1] := 0
  OUTB[3..7] := 1

  OUTA[0]++
  OUTB[1]~~

  OUTA[0..1] := INB[3..7]

  OUTA[0..1] := INB[3..7]++
  
PRI test_Repeat

  Repeat
    b := 0
  Repeat
    b := 1
    Repeat
      b := 2
    
PRI test_Repeat_Count

  Repeat 10
    b++

PRI test_Repeat_FromTo

  Repeat b From 0 To 10
    b++

  Repeat b From 0 To 10 Step 1
    b++
    
  Repeat b From 10 To 0 Step -1
    b++   
    
PRI test_Repeat_Until

  Repeat until b > 10
    b++

  Repeat
    b++
  Until b > 10
  
PRI test_Repeat_While

  Repeat while b > 10
    b++

  Repeat
    b++
  While b > 10
  
PRI test_Repeat_With_Next

  Repeat while b > 10
    b++
    Next
    b--

  Repeat
    b++
    Next
    b--
  While b > 10
  
PRI test_Repeat_With_Quit

  Repeat while b > 10
    b++
    Quit
    b--

  Repeat
    b++
    Quit
    b--
  While b > 10

  
PRI test_Strings

  b := StrComp( @b, @b )
  b := String( "Xyzzy" )
  b := StrSize( @b )

PRI test_UnaryOps

  -b
  ++b
  --b
  b++
  b--
  
  ! b
  NOT b  

  ^^ b
  || b

  
  ~b
  ~~b
  b~
  b~~

  ?b
  b?

  |< b
  >| b

PRI test_UnaryOps_Assigned

  b := ( b := b )
  
  b := +b
  b := -b
  b := ++b
  b := --b
  b := b++
  b := b--

  b := ! b
  b := NOT b  

  b := ^^ b
  b := || b

  b := ~b
  b := ~~b
  b := b~
  b := b~~

  b := ?b
  b := b?

  b := |< b
  b := >| b

  b := @b

PRI test_Vars | bLocal, wLocal, lLocal

  b := 1
  w := 2
  l := 3

  bOverlay := 1
  wOverlay := 2
  lOverlay := 3

  bOverlayEnd := 1
  wOverlayEnd := 2
  lOverlayEnd := 3
  
  bLocal := 1
  wLocal := 2
  lLocal := 3

PRI test_Vars_Casting

  l.byte := l.byte
  l.word := l.word
  l.long := l.long
  
  l.byte[1] := l.byte[1]
  l.word[2] := l.word[2]
  l.long[3] := l.long[3]

PRI test_Vars_Data

  bData := bData[0]
  wData := wData[1]
  lData := lData[3]

  bData[0] := bData
  wData[1] := wData
  lData[3] := lData
  
PRI test_Vars_Local |t0, t1, t2, t3, t4, t5, t6, t7, t8

  t0 := t0
  t1 := t1
  t2 := t2
  t3 := t3
  t4 := t4
  t5 := t5
  t6 := t6
  t7 := t7
  t8 := t8

  t0++
  t1++
  t2++
  t3++
  t4++
  t5++
  t6++
  t7++
  t8++
  
PRI test_Wait

  WaitCnt( 0 )
  WaitPeq( 0, 1, 2)
  WaitPne( 0, 1, 2 )
  WaitVid( 0, 1 )

DAT
 
        ORG 0

Conds   IF_NEVER     ADD     dd,ss
        IF_NC_AND_NZ ADD     dd,ss
        IF_NC_AND_Z  ADD     dd,ss
        IF_NC        ADD     dd,ss
        IF_C_AND_NZ  ADD     dd,ss
        IF_NZ        ADD     dd,ss
        IF_C_NE_Z    ADD     dd,ss
        IF_NC_OR_NZ  ADD     dd,ss
        IF_C_AND_Z   ADD     dd,ss
        IF_C_EQ_Z    ADD     dd,ss
        IF_Z         ADD     dd,ss
        IF_NC_OR_Z   ADD     dd,ss
        IF_C         ADD     dd,ss
        IF_C_OR_NZ   ADD     dd,ss
        IF_C_OR_Z    ADD     dd,ss
        IF_ALWAYS    ADD     dd,ss

                     add     $40,$41  ' Outside the area here
                     add     $50,$52
                     
CondsEnd             JMP     #CondsEnd
  
dd      long 0
ss      long 0

DAT

        ORG 0
        
Opcodes              ABS     d,s
                     ABSNEG  d,s
                     ADD     d,s
                     ADDABS  d,s
                     ADDS    d,s
                     ADDSX   d,s
                     ADDX    d,s
                     AND     d,s
                     ANDN    d,s
                     CLKSET  d
                     CMP     d,s
                     CMPS    d,s
                     CMPSUB  d,s
                     CMPSX   d,s
                     CMPX    d,s
                     COGID   d
                     COGINIT d
                     COGSTOP d
                     DJNZ    d,s
                     HUBOP   d,s
                     HUBOP   d,s
                     LOCKCLR d
                     LOCKNEW d
                     LOCKRET d
                     LOCKSET d
                     MAX     d,s
                     MAXS    d,s
                     MIN     d,s
                     MINS    d,s
                     MOV     d,s
                     MOVD    d,s
                     MOVI    d,s
                     MOVS    d,s
                     MUXC    d,s
                     MUXNC   d,s
                     MUXNZ   d,s
                     MUXZ    d,s
                     NEG     d,s
                     NEGC    d,s
                     NEGNC   d,s
                     NEGNZ   d,s
                     NEGZ    d,s
                     NOP
                     OR      d,s
                     RCL     d,s
                     RCR     d,s
                     RDBYTE  d,s
                     RDLONG  d,s
                     RDWORD  d,s
                     REV     d,s
                     ROL     d,s
                     ROR     d,s
                     SAR     d,s
                     SHL     d,s
                     SHR     d,s
                     SUB     d,s
                     SUBABS  d,s
                     SUBS    d,s
                     SUBSX   d,s
                     SUBX    d,s
                     SUMC    d,s
                     SUMNC   d,s
                     SUMNZ   d,s
                     SUMZ    d,s
                     TEST    d,s
                     TJNZ    d,s
                     TJZ     d,s
                     WAITCNT d,s
                     WAITPEQ d,s
                     WAITPNE d,s
                     WAITVID d,s
                     WRBYTE  d,s
                     WRLONG  d,s
                     WRWORD  d,s
                     XOR     d,s
                     
                     ABS     d,#s
                     ABSNEG  d,#s
                     ADD     d,#s
                     ADDABS  d,#s
                     ADDS    d,#s
                     ADDSX   d,#s
                     ADDX    d,#s
                     AND     d,#s
                     ANDN    d,#s
                     CALL    #TestJmp
                     CALL    #TestJmpRet
                     CALL    #TestJmpReg
                     CLKSET  d
                     CMP     d,#s
                     CMPS    d,#s
                     CMPSUB  d,#s
                     CMPSX   d,#s
                     CMPX    d,#s
                     COGID   d
                     COGINIT d
                     COGSTOP d
                     DJNZ    d,#TestJmp
                     HUBOP   d,#s
                     HUBOP   d,#s
                     LOCKCLR d
                     LOCKNEW d
                     LOCKRET d
                     LOCKSET d
                     MAX     d,#s
                     MAXS    d,#s
                     MIN     d,#s
                     MINS    d,#s
                     MOV     d,#s
                     MOVD    d,#s
                     MOVI    d,#s
                     MOVS    d,#s
                     MUXC    d,#s
                     MUXNC   d,#s
                     MUXNZ   d,#s
                     MUXZ    d,#s
                     NEG     d,#s
                     NEGC    d,#s
                     NEGNC   d,#s
                     NEGNZ   d,#s
                     NEGZ    d,#s
                     NOP
                     OR      d,#s
                     RCL     d,#s
                     RCR     d,#s
                     RDBYTE  d,#s
                     RDLONG  d,#s
                     RDWORD  d,#s
                     REV     d,#s
                     ROL     d,#s
                     ROR     d,#s
                     SAR     d,#s
                     SHL     d,#s
                     SHR     d,#s
                     SUB     d,#s
                     SUBABS  d,#s
                     SUBS    d,#s
                     SUBSX   d,#s
                     SUBX    d,#s
                     SUMC    d,#s
                     SUMNC   d,#s
                     SUMNZ   d,#s
                     SUMZ    d,#s
                     TEST    d,#s
                     TJNZ    d,#TestJmp
                     TJZ     d,#TestJmp
                     WAITCNT d,#s
                     WAITPEQ d,#s
                     WAITPNE d,#s
                     WAITVID d,#s
                     WRBYTE  d,#s
                     WRLONG  d,#s
                     WRWORD  d,#s
                     XOR     d,#s
                     
Opcodes_Ret          RET
             
TestJmp              JMPRET  TestJmpRet_Ret,#TestJmpRet
                     JMP     #Opcodes
TestJmp_Ret          RET

TestJmpRet           JMPRET  Opcodes_ret,#TestJmp
TestJmpRet_Ret       RET

TestJmpReg           JMPRET  Opcodes_ret,s

                     add     $1D0,$1D1  ' Outside the area here
                     add     $1E0,$1E2

TestJmpReg_Ret       RET

d                    LONG    0
s                    LONG    0
  
